// gcc -Wall -Wpedantic -Wextra -std=c17 -march=native -g -O1 alignment-padding.c && ./a.out

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>


typedef struct  {
    uint32_t a;
    uint8_t  b;
    uint32_t c;
    uint8_t  d;
} stuff;

typedef struct  {
    uint32_t a;
    uint8_t  b;
    uint8_t  padding1;
    uint8_t  padding2;
    uint8_t  padding3;
    uint32_t c;
    uint8_t  d;
    uint8_t  padding4;
    uint8_t  padding5;
    uint8_t  padding6;
} stuff2;


int main() {
    stuff s = {.a=0x12345678, .b=0xff, .c=0x01010101, .d=0x44};
    uint8_t* p = (uint8_t*)&s;
    for (unsigned i = 0; i < sizeof(stuff); i++) {
        printf("*(p+%d) == 0x%02x\n", i, *(p + i));
    }
    uint64_t address_a = (uint64_t) & (s.a);
    uint64_t address_c = (uint64_t) & (s.c);
    printf("%lu\n", address_a % sizeof(uint32_t));
    printf("%lu\n", address_c % sizeof(uint32_t));
    printf("%lu\n", sizeof(stuff));
    printf("%lu\n", sizeof(stuff2));
    return 0;
}

